<html>
<head>
<title>OgreIteratorRange.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreIteratorRange.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreIteratorRange_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __Ogre_Iterator_Range_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __Ogre_Iterator_Range_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">//#define OGRE_USE_BOOST 1 - picked up by CMake</span>
<a name="l00033"></a>00033 <span class="preprocessor">#if OGRE_USE_BOOST</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span><span class="preprocessor">#include &lt;boost/range.hpp&gt;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#endif</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span>
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00038"></a>00038 
<a name="l00050"></a>00050 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00051"></a><a class="code" href="classOgre_1_1iterator__range.html">00051</a> <span class="keyword">class </span><a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">iterator_range</a>{
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 <span class="preprocessor">#if !OGRE_USE_BOOST</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span>    
<a name="l00055"></a><a class="code" href="classOgre_1_1iterator__range.html#ab0e1d0f0da198e6e086a80caca1a2bc5">00055</a>     T <a class="code" href="classOgre_1_1iterator__range.html#af9d832887bbab554a2d6fedf61c1ee0b">mBegin</a>, <a class="code" href="classOgre_1_1iterator__range.html#ab0e1d0f0da198e6e086a80caca1a2bc5">mEnd</a>;
<a name="l00056"></a>00056     
<a name="l00057"></a>00057     <span class="keyword">public</span> : 
<a name="l00058"></a>00058     
<a name="l00063"></a><a class="code" href="classOgre_1_1iterator__range.html#a1f2f3f2591ef271a80972f00cf26a72b">00063</a>         <a class="code" href="classOgre_1_1iterator__range.html#a1f2f3f2591ef271a80972f00cf26a72b" title="Constructor.">iterator_range</a>( T b , T e ) : <a class="code" href="classOgre_1_1iterator__range.html#af9d832887bbab554a2d6fedf61c1ee0b">mBegin</a>(b) , <a class="code" href="classOgre_1_1iterator__range.html#ab0e1d0f0da198e6e086a80caca1a2bc5">mEnd</a>(e){}
<a name="l00064"></a>00064 
<a name="l00066"></a><a class="code" href="classOgre_1_1iterator__range.html#a467f301e60a78b882eef63960e5a3710">00066</a>         T <a class="code" href="classOgre_1_1iterator__range.html#a467f301e60a78b882eef63960e5a3710" title="access to the begin of the range">begin</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1iterator__range.html#af9d832887bbab554a2d6fedf61c1ee0b">mBegin</a>; }
<a name="l00067"></a>00067         
<a name="l00069"></a><a class="code" href="classOgre_1_1iterator__range.html#ae3e787878186259e1316dc9c4ae650c7">00069</a>         T <a class="code" href="classOgre_1_1iterator__range.html#ae3e787878186259e1316dc9c4ae650c7" title="access to the end of the range">end</a>()<span class="keyword"> const   </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1iterator__range.html#ab0e1d0f0da198e6e086a80caca1a2bc5">mEnd</a>;  }   
<a name="l00070"></a>00070 
<a name="l00072"></a><a class="code" href="classOgre_1_1iterator__range.html#a84cf9ef91a48bee02212d3c11a3ebc86">00072</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1iterator__range.html#a84cf9ef91a48bee02212d3c11a3ebc86" title="informs if there are any elements in the range">empty</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1iterator__range.html#af9d832887bbab554a2d6fedf61c1ee0b">mBegin</a> = <a class="code" href="classOgre_1_1iterator__range.html#ab0e1d0f0da198e6e086a80caca1a2bc5">mEnd</a> ; }
<a name="l00073"></a>00073 
<a name="l00075"></a><a class="code" href="classOgre_1_1iterator__range.html#a31907d72258f80d10cb91692e933d460">00075</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1iterator__range.html#a31907d72258f80d10cb91692e933d460" title="comparison for equality">equal</a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">iterator_range</a>&amp; other )<span class="keyword"> const  </span>
<a name="l00076"></a>00076 <span class="keyword">        </span>{<span class="keywordflow">return</span> <a class="code" href="classOgre_1_1iterator__range.html#af9d832887bbab554a2d6fedf61c1ee0b">mBegin</a> == other.<a class="code" href="classOgre_1_1iterator__range.html#af9d832887bbab554a2d6fedf61c1ee0b">mBegin</a> &amp;&amp; <a class="code" href="classOgre_1_1iterator__range.html#ab0e1d0f0da198e6e086a80caca1a2bc5">mEnd</a> == other.<a class="code" href="classOgre_1_1iterator__range.html#ab0e1d0f0da198e6e086a80caca1a2bc5">mEnd</a>;}
<a name="l00077"></a>00077 
<a name="l00079"></a><a class="code" href="classOgre_1_1iterator__range.html#a01990c202e6bd67252ac627ecf483a96">00079</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1iterator__range.html#a01990c202e6bd67252ac627ecf483a96" title="comparison operator for equality">operator==</a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">iterator_range</a>&amp; rhs )<span class="keyword"> const</span>
<a name="l00080"></a>00080 <span class="keyword">        </span>{<span class="keywordflow">return</span> <a class="code" href="classOgre_1_1iterator__range.html#a31907d72258f80d10cb91692e933d460" title="comparison for equality">equal</a>( rhs ) ;}
<a name="l00081"></a>00081     
<a name="l00083"></a><a class="code" href="classOgre_1_1iterator__range.html#aecc617f3aaba85f9d29eb60b7dab98d8">00083</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1iterator__range.html#aecc617f3aaba85f9d29eb60b7dab98d8" title="comparison operator for inequality">operator!=</a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">iterator_range</a>&amp; rhs )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !<a class="code" href="classOgre_1_1iterator__range.html#a01990c202e6bd67252ac627ecf483a96" title="comparison operator for equality">operator==</a>(rhs); }
<a name="l00084"></a>00084 
<a name="l00091"></a><a class="code" href="classOgre_1_1iterator__range.html#a506c90799fd48937b85cbd37497fcf1b">00091</a>         <span class="keyword">typedef</span> T <a class="code" href="classOgre_1_1iterator__range.html#a506c90799fd48937b85cbd37497fcf1b" title="typedef to fulfill container interface">iterator</a>;
<a name="l00092"></a>00092         
<a name="l00099"></a><a class="code" href="classOgre_1_1iterator__range.html#a63c42093c4a283c7f1954970f83cc342">00099</a>         <span class="keyword">typedef</span> T <a class="code" href="classOgre_1_1iterator__range.html#a63c42093c4a283c7f1954970f83cc342" title="typedef to fulfill container interface">const_iterator</a>;
<a name="l00100"></a>00100         
<a name="l00102"></a>00102 
<a name="l00106"></a><a class="code" href="classOgre_1_1iterator__range.html#a3f5e91d206f12b980bc27eb0c0c8c4e5">00106</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">iterator_range&lt;T&gt;</a> <a class="code" href="classOgre_1_1iterator__range.html#a3f5e91d206f12b980bc27eb0c0c8c4e5" title="defines the real used type">type</a>;
<a name="l00107"></a>00107 <span class="preprocessor">#else</span>
<a name="l00108"></a>00108 <span class="preprocessor"></span>
<a name="l00109"></a>00109         <span class="keyword">public</span>: <span class="keyword">typedef</span> boost::iterator_range&lt;T&gt; <a class="code" href="classOgre_1_1iterator__range.html#a3f5e91d206f12b980bc27eb0c0c8c4e5" title="defines the real used type">type</a> ;
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 <span class="preprocessor">#endif</span>
<a name="l00112"></a>00112 <span class="preprocessor"></span>}; 
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00123"></a>00123 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00124"></a><a class="code" href="structOgre_1_1VectorRange.html">00124</a> <span class="keyword">struct </span><a class="code" href="structOgre_1_1VectorRange.html" title="Predefined type.">VectorRange</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">iterator_range</a>&lt;typename T::iterator&gt;::<a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">type</a>
<a name="l00125"></a>00125 {
<a name="l00126"></a>00126 
<a name="l00131"></a><a class="code" href="structOgre_1_1VectorRange.html#a8bd99d542cd003599a7fbda21ee393ec">00131</a>     <a class="code" href="structOgre_1_1VectorRange.html#a8bd99d542cd003599a7fbda21ee393ec" title="Constructor.">VectorRange</a>( T&amp; c )
<a name="l00132"></a>00132     : <a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">iterator_range</a>&lt;typename T::<a class="code" href="classOgre_1_1iterator__range.html#a506c90799fd48937b85cbd37497fcf1b" title="typedef to fulfill container interface">iterator</a>&gt;::<a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">type</a>( c.<a class="code" href="classOgre_1_1iterator__range.html#a467f301e60a78b882eef63960e5a3710" title="access to the begin of the range">begin</a>(), c.<a class="code" href="classOgre_1_1iterator__range.html#ae3e787878186259e1316dc9c4ae650c7" title="access to the end of the range">end</a>() )
<a name="l00133"></a>00133     {}
<a name="l00134"></a>00134 
<a name="l00139"></a><a class="code" href="structOgre_1_1VectorRange.html#a1eb84299f8158ab7ad3cbbba552cba42">00139</a>     <a class="code" href="structOgre_1_1VectorRange.html#a8bd99d542cd003599a7fbda21ee393ec" title="Constructor.">VectorRange</a>( <span class="keyword">typename</span> T::iterator b, <span class="keyword">typename</span> T::iterator e )
<a name="l00140"></a>00140     : <a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">iterator_range</a>&lt;typename T::<a class="code" href="classOgre_1_1iterator__range.html#a506c90799fd48937b85cbd37497fcf1b" title="typedef to fulfill container interface">iterator</a>&gt;::<a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">type</a>( b, e )
<a name="l00141"></a>00141     {}
<a name="l00142"></a>00142 
<a name="l00144"></a><a class="code" href="structOgre_1_1VectorRange.html#ac27a09e291addc82f218de4e2c97c1a5">00144</a>     <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1VectorRange.html#ac27a09e291addc82f218de4e2c97c1a5" title="comparison operator for equality">operator==</a>( <span class="keyword">const</span> <a class="code" href="structOgre_1_1VectorRange.html" title="Predefined type.">VectorRange</a>&amp; rhs )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1iterator__range.html#a31907d72258f80d10cb91692e933d460" title="comparison for equality">equal</a>( rhs) ; }
<a name="l00146"></a><a class="code" href="structOgre_1_1VectorRange.html#a1c3c6354d896c737cbfc5d7597b8e26a">00146</a>     <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1VectorRange.html#a1c3c6354d896c737cbfc5d7597b8e26a" title="comparison operator for inequality">operator!=</a>( <span class="keyword">const</span> <a class="code" href="structOgre_1_1VectorRange.html" title="Predefined type.">VectorRange</a>&amp; rhs )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !<a class="code" href="classOgre_1_1iterator__range.html#a31907d72258f80d10cb91692e933d460" title="comparison for equality">equal</a>( rhs) ; }
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 <span class="preprocessor">#ifdef __Ogre_Iterator_Wrapper_H__</span>
<a name="l00150"></a>00150 <span class="preprocessor"></span>
<a name="l00151"></a>00151     operator VectorIterator&lt;T&gt;(){<span class="keywordflow">return</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">VectorIterator&lt;T&gt;</a>( this-&gt;<a class="code" href="classOgre_1_1iterator__range.html#a467f301e60a78b882eef63960e5a3710" title="access to the begin of the range">begin</a>(), this-&gt;<a class="code" href="classOgre_1_1iterator__range.html#ae3e787878186259e1316dc9c4ae650c7" title="access to the end of the range">end</a>());}
<a name="l00153"></a>00153     operator ConstVectorIterator&lt;T&gt;(){<span class="keywordflow">return</span> ConstVectorIterator&lt;T&gt;( this-&gt;<a class="code" href="classOgre_1_1iterator__range.html#a467f301e60a78b882eef63960e5a3710" title="access to the begin of the range">begin</a>(), this-&gt;<a class="code" href="classOgre_1_1iterator__range.html#ae3e787878186259e1316dc9c4ae650c7" title="access to the end of the range">end</a>());}
<a name="l00154"></a>00154 <span class="preprocessor">#endif</span>
<a name="l00155"></a>00155 <span class="preprocessor"></span>    
<a name="l00156"></a>00156 };
<a name="l00157"></a>00157 
<a name="l00166"></a>00166 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00167"></a><a class="code" href="structOgre_1_1ConstVectorRange.html">00167</a> <span class="keyword">struct </span><a class="code" href="structOgre_1_1ConstVectorRange.html" title="Predefined type.">ConstVectorRange</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">iterator_range</a>&lt;typename T::const_iterator&gt;::<a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">type</a>
<a name="l00168"></a>00168 {
<a name="l00169"></a>00169 
<a name="l00174"></a><a class="code" href="structOgre_1_1ConstVectorRange.html#af00c5834173f39be1b54c6861b5b3c5b">00174</a>     <a class="code" href="structOgre_1_1ConstVectorRange.html#af00c5834173f39be1b54c6861b5b3c5b" title="Constructor.">ConstVectorRange</a>( <span class="keyword">const</span> T&amp; c )
<a name="l00175"></a>00175     : <a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">iterator_range</a>&lt;typename T::<a class="code" href="classOgre_1_1iterator__range.html#a63c42093c4a283c7f1954970f83cc342" title="typedef to fulfill container interface">const_iterator</a>&gt;::<a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">type</a>( c.<a class="code" href="classOgre_1_1iterator__range.html#a467f301e60a78b882eef63960e5a3710" title="access to the begin of the range">begin</a>(), c.<a class="code" href="classOgre_1_1iterator__range.html#ae3e787878186259e1316dc9c4ae650c7" title="access to the end of the range">end</a>() )
<a name="l00176"></a>00176     {}
<a name="l00177"></a>00177 
<a name="l00182"></a><a class="code" href="structOgre_1_1ConstVectorRange.html#abbac80afff529edc25267647a0737cca">00182</a>     <a class="code" href="structOgre_1_1ConstVectorRange.html#af00c5834173f39be1b54c6861b5b3c5b" title="Constructor.">ConstVectorRange</a>( <span class="keyword">typename</span> T::iterator b, <span class="keyword">typename</span> T::iterator e )
<a name="l00183"></a>00183     : <a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">iterator_range</a>&lt;typename T::<a class="code" href="classOgre_1_1iterator__range.html#a63c42093c4a283c7f1954970f83cc342" title="typedef to fulfill container interface">const_iterator</a>&gt;::<a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">type</a>( b, e )
<a name="l00184"></a>00184     {}
<a name="l00185"></a>00185 
<a name="l00190"></a><a class="code" href="structOgre_1_1ConstVectorRange.html#ab43c3edd2f1fe8ce13634ce6fa7af386">00190</a>     <a class="code" href="structOgre_1_1ConstVectorRange.html#af00c5834173f39be1b54c6861b5b3c5b" title="Constructor.">ConstVectorRange</a>( <span class="keyword">typename</span> T::const_iterator b, <span class="keyword">typename</span> T::const_iterator e )
<a name="l00191"></a>00191     : <a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">iterator_range</a>&lt;typename T::<a class="code" href="classOgre_1_1iterator__range.html#a63c42093c4a283c7f1954970f83cc342" title="typedef to fulfill container interface">const_iterator</a>&gt;::<a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">type</a>( b, e )
<a name="l00192"></a>00192     {}
<a name="l00193"></a>00193 
<a name="l00198"></a><a class="code" href="structOgre_1_1ConstVectorRange.html#a08698de0448172f19385cc3c33c9b00a">00198</a>     <a class="code" href="structOgre_1_1ConstVectorRange.html#af00c5834173f39be1b54c6861b5b3c5b" title="Constructor.">ConstVectorRange</a>( <span class="keyword">const</span> <a class="code" href="structOgre_1_1VectorRange.html" title="Predefined type.">VectorRange&lt;T&gt;</a>&amp; rhs  )
<a name="l00199"></a>00199     : <a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">iterator_range</a>&lt;typename T::<a class="code" href="classOgre_1_1iterator__range.html#a63c42093c4a283c7f1954970f83cc342" title="typedef to fulfill container interface">const_iterator</a>&gt;::<a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">type</a>( rhs.<a class="code" href="classOgre_1_1iterator__range.html#a467f301e60a78b882eef63960e5a3710" title="access to the begin of the range">begin</a>(), rhs.<a class="code" href="classOgre_1_1iterator__range.html#ae3e787878186259e1316dc9c4ae650c7" title="access to the end of the range">end</a>() )
<a name="l00200"></a>00200     {}
<a name="l00201"></a>00201 
<a name="l00203"></a><a class="code" href="structOgre_1_1ConstVectorRange.html#abda094f78b6cc649530d79ad777f58bd">00203</a>     <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1ConstVectorRange.html#abda094f78b6cc649530d79ad777f58bd" title="comparison operator for equality">operator==</a>( <span class="keyword">const</span> <a class="code" href="structOgre_1_1ConstVectorRange.html" title="Predefined type.">ConstVectorRange</a>&amp; rhs )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1iterator__range.html#a31907d72258f80d10cb91692e933d460" title="comparison for equality">equal</a>( rhs) ; }
<a name="l00205"></a><a class="code" href="structOgre_1_1ConstVectorRange.html#a6e52fe8c0c687e085fcb813957e40a13">00205</a>     <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1ConstVectorRange.html#a6e52fe8c0c687e085fcb813957e40a13" title="comparison operator for inequality">operator!=</a>( <span class="keyword">const</span> <a class="code" href="structOgre_1_1ConstVectorRange.html" title="Predefined type.">ConstVectorRange</a>&amp; rhs )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !<a class="code" href="classOgre_1_1iterator__range.html#a31907d72258f80d10cb91692e933d460" title="comparison for equality">equal</a>( rhs) ; }
<a name="l00206"></a>00206     
<a name="l00207"></a>00207     
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 <span class="preprocessor">#ifdef __Ogre_Iterator_Wrapper_H__</span>
<a name="l00211"></a>00211 <span class="preprocessor"></span>
<a name="l00212"></a>00212     operator ConstVectorIterator&lt;T&gt;(){<span class="keywordflow">return</span>  <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">ConstVectorIterator&lt;T&gt;</a>( this-&gt;<a class="code" href="classOgre_1_1iterator__range.html#a467f301e60a78b882eef63960e5a3710" title="access to the begin of the range">begin</a>(),this-&gt;<a class="code" href="classOgre_1_1iterator__range.html#ae3e787878186259e1316dc9c4ae650c7" title="access to the end of the range">end</a>());}
<a name="l00213"></a>00213 <span class="preprocessor">#endif</span>
<a name="l00214"></a>00214 <span class="preprocessor"></span>    
<a name="l00215"></a>00215 };
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00227"></a>00227 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00228"></a><a class="code" href="structOgre_1_1MapRange.html">00228</a> <span class="keyword">struct </span><a class="code" href="structOgre_1_1MapRange.html" title="Predefined type.">MapRange</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">iterator_range</a>&lt;typename T::iterator&gt;::<a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">type</a>
<a name="l00229"></a>00229 {
<a name="l00234"></a><a class="code" href="structOgre_1_1MapRange.html#aee319e8d25cf55d01de56be75b7f32a9">00234</a>     <a class="code" href="structOgre_1_1MapRange.html#aee319e8d25cf55d01de56be75b7f32a9" title="Constructor.">MapRange</a>( T&amp; c )
<a name="l00235"></a>00235     : <a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">iterator_range</a>&lt;typename T::<a class="code" href="classOgre_1_1iterator__range.html#a506c90799fd48937b85cbd37497fcf1b" title="typedef to fulfill container interface">iterator</a>&gt;::<a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">type</a>( c.<a class="code" href="classOgre_1_1iterator__range.html#a467f301e60a78b882eef63960e5a3710" title="access to the begin of the range">begin</a>(), c.<a class="code" href="classOgre_1_1iterator__range.html#ae3e787878186259e1316dc9c4ae650c7" title="access to the end of the range">end</a>() )
<a name="l00236"></a>00236     {}
<a name="l00237"></a>00237 
<a name="l00242"></a><a class="code" href="structOgre_1_1MapRange.html#a456e78d6bdebffac171f31778dfa08cc">00242</a>     <a class="code" href="structOgre_1_1MapRange.html#aee319e8d25cf55d01de56be75b7f32a9" title="Constructor.">MapRange</a>( <span class="keyword">typename</span> T::iterator b, <span class="keyword">typename</span> T::iterator e )
<a name="l00243"></a>00243     : <a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">iterator_range</a>&lt;typename T::<a class="code" href="classOgre_1_1iterator__range.html#a506c90799fd48937b85cbd37497fcf1b" title="typedef to fulfill container interface">iterator</a>&gt;::<a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">type</a>( b, e )
<a name="l00244"></a>00244     {}
<a name="l00245"></a>00245 
<a name="l00247"></a><a class="code" href="structOgre_1_1MapRange.html#ae6acfdcd7e0a03f0afb2ab13df96a7b2">00247</a>     <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1MapRange.html#ae6acfdcd7e0a03f0afb2ab13df96a7b2" title="comparison operator for equality">operator==</a>( <span class="keyword">const</span> <a class="code" href="structOgre_1_1MapRange.html" title="Predefined type.">MapRange</a>&amp; rhs )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1iterator__range.html#a31907d72258f80d10cb91692e933d460" title="comparison for equality">equal</a>( rhs) ; }
<a name="l00249"></a><a class="code" href="structOgre_1_1MapRange.html#a0ddbb636763b969480f95b469141080b">00249</a>     <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1MapRange.html#a0ddbb636763b969480f95b469141080b" title="comparison operator for inequality">operator!=</a>( <span class="keyword">const</span> <a class="code" href="structOgre_1_1MapRange.html" title="Predefined type.">MapRange</a>&amp; rhs )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !<a class="code" href="classOgre_1_1iterator__range.html#a31907d72258f80d10cb91692e933d460" title="comparison for equality">equal</a>( rhs) ; }
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 
<a name="l00252"></a>00252 <span class="preprocessor">#ifdef __Ogre_Iterator_Wrapper_H__</span>
<a name="l00253"></a>00253 <span class="preprocessor"></span>
<a name="l00254"></a>00254     operator MapIterator&lt;T&gt;(){<span class="keywordflow">return</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">MapIterator&lt;T&gt;</a>( this-&gt;<a class="code" href="classOgre_1_1iterator__range.html#a467f301e60a78b882eef63960e5a3710" title="access to the begin of the range">begin</a>(), this-&gt;<a class="code" href="classOgre_1_1iterator__range.html#ae3e787878186259e1316dc9c4ae650c7" title="access to the end of the range">end</a>());}
<a name="l00256"></a>00256     operator ConstMapIterator&lt;T&gt;(){<span class="keywordflow">return</span> ConstMapIterator&lt;T&gt;( this-&gt;<a class="code" href="classOgre_1_1iterator__range.html#a467f301e60a78b882eef63960e5a3710" title="access to the begin of the range">begin</a>(), this-&gt;<a class="code" href="classOgre_1_1iterator__range.html#ae3e787878186259e1316dc9c4ae650c7" title="access to the end of the range">end</a>());}
<a name="l00257"></a>00257 <span class="preprocessor">#endif</span>
<a name="l00258"></a>00258 <span class="preprocessor"></span>    
<a name="l00259"></a>00259 };
<a name="l00260"></a>00260 
<a name="l00269"></a>00269 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00270"></a><a class="code" href="structOgre_1_1ConstMapRange.html">00270</a> <span class="keyword">struct </span><a class="code" href="structOgre_1_1ConstMapRange.html" title="Predefined type.">ConstMapRange</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">iterator_range</a>&lt;typename T::const_iterator&gt;::<a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">type</a>
<a name="l00271"></a>00271 {
<a name="l00272"></a>00272 
<a name="l00277"></a><a class="code" href="structOgre_1_1ConstMapRange.html#a70ea483003fc1e4c67ddb97a1d5146a4">00277</a>     <a class="code" href="structOgre_1_1ConstMapRange.html#a70ea483003fc1e4c67ddb97a1d5146a4" title="Constructor.">ConstMapRange</a>( <span class="keyword">const</span> T&amp; c )
<a name="l00278"></a>00278     : <a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">iterator_range</a>&lt;typename T::<a class="code" href="classOgre_1_1iterator__range.html#a63c42093c4a283c7f1954970f83cc342" title="typedef to fulfill container interface">const_iterator</a>&gt;::<a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">type</a>( c.<a class="code" href="classOgre_1_1iterator__range.html#a467f301e60a78b882eef63960e5a3710" title="access to the begin of the range">begin</a>(), c.<a class="code" href="classOgre_1_1iterator__range.html#ae3e787878186259e1316dc9c4ae650c7" title="access to the end of the range">end</a>() )
<a name="l00279"></a>00279     {}
<a name="l00280"></a>00280 
<a name="l00285"></a><a class="code" href="structOgre_1_1ConstMapRange.html#a3a296e68a7f915753b7724e61439fe08">00285</a>     <a class="code" href="structOgre_1_1ConstMapRange.html#a70ea483003fc1e4c67ddb97a1d5146a4" title="Constructor.">ConstMapRange</a>( <span class="keyword">typename</span> T::iterator b, <span class="keyword">typename</span> T::iterator e )
<a name="l00286"></a>00286     : <a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">iterator_range</a>&lt;typename T::<a class="code" href="classOgre_1_1iterator__range.html#a63c42093c4a283c7f1954970f83cc342" title="typedef to fulfill container interface">const_iterator</a>&gt;::<a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">type</a>( b, e )
<a name="l00287"></a>00287     {}
<a name="l00288"></a>00288     
<a name="l00293"></a><a class="code" href="structOgre_1_1ConstMapRange.html#a08baf8ef2777b1b33c367c395b269edd">00293</a>     <a class="code" href="structOgre_1_1ConstMapRange.html#a70ea483003fc1e4c67ddb97a1d5146a4" title="Constructor.">ConstMapRange</a>( <span class="keyword">typename</span> T::const_iterator b, <span class="keyword">typename</span> T::const_iterator e )
<a name="l00294"></a>00294     : <a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">iterator_range</a>&lt;typename T::<a class="code" href="classOgre_1_1iterator__range.html#a63c42093c4a283c7f1954970f83cc342" title="typedef to fulfill container interface">const_iterator</a>&gt;::<a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">type</a>( b, e )
<a name="l00295"></a>00295     {}
<a name="l00296"></a>00296 
<a name="l00301"></a><a class="code" href="structOgre_1_1ConstMapRange.html#ade652ae33eb3952d98d75bfc15ea7be4">00301</a>     <a class="code" href="structOgre_1_1ConstMapRange.html#a70ea483003fc1e4c67ddb97a1d5146a4" title="Constructor.">ConstMapRange</a>( <span class="keyword">const</span> <a class="code" href="structOgre_1_1MapRange.html" title="Predefined type.">MapRange&lt;T&gt;</a>&amp; rhs  )
<a name="l00302"></a>00302     : <a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">iterator_range</a>&lt;typename T::<a class="code" href="classOgre_1_1iterator__range.html#a63c42093c4a283c7f1954970f83cc342" title="typedef to fulfill container interface">const_iterator</a>&gt;::<a class="code" href="classOgre_1_1iterator__range.html" title="Base for an iterator_range.">type</a>( rhs.<a class="code" href="classOgre_1_1iterator__range.html#a467f301e60a78b882eef63960e5a3710" title="access to the begin of the range">begin</a>(), rhs.<a class="code" href="classOgre_1_1iterator__range.html#ae3e787878186259e1316dc9c4ae650c7" title="access to the end of the range">end</a>() )
<a name="l00303"></a>00303     {}
<a name="l00304"></a>00304     
<a name="l00306"></a><a class="code" href="structOgre_1_1ConstMapRange.html#a60428175e846043313f152132a156166">00306</a>     <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1ConstMapRange.html#a60428175e846043313f152132a156166" title="comparison operator for equality">operator==</a>( <span class="keyword">const</span> <a class="code" href="structOgre_1_1ConstMapRange.html" title="Predefined type.">ConstMapRange</a>&amp; rhs )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1iterator__range.html#a31907d72258f80d10cb91692e933d460" title="comparison for equality">equal</a>( rhs) ; }
<a name="l00308"></a><a class="code" href="structOgre_1_1ConstMapRange.html#a922418485ab2a595f9646c0c11e4679d">00308</a>     <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1ConstMapRange.html#a922418485ab2a595f9646c0c11e4679d" title="comparison operator for inequality">operator!=</a>( <span class="keyword">const</span> <a class="code" href="structOgre_1_1ConstMapRange.html" title="Predefined type.">ConstMapRange</a>&amp; rhs )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !<a class="code" href="classOgre_1_1iterator__range.html#a31907d72258f80d10cb91692e933d460" title="comparison for equality">equal</a>( rhs) ; }
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 
<a name="l00311"></a>00311 <span class="preprocessor">#ifdef __Ogre_Iterator_Wrapper_H__</span>
<a name="l00312"></a>00312 <span class="preprocessor"></span>
<a name="l00313"></a>00313     operator ConstMapIterator&lt;T&gt;(){<span class="keywordflow">return</span>  <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">ConstMapIterator&lt;T&gt;</a>( this-&gt;<a class="code" href="classOgre_1_1iterator__range.html#a467f301e60a78b882eef63960e5a3710" title="access to the begin of the range">begin</a>(),this-&gt;<a class="code" href="classOgre_1_1iterator__range.html#ae3e787878186259e1316dc9c4ae650c7" title="access to the end of the range">end</a>());}
<a name="l00314"></a>00314 <span class="preprocessor">#endif</span>
<a name="l00315"></a>00315 <span class="preprocessor"></span>    
<a name="l00316"></a>00316 };
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 
<a name="l00319"></a>00319 
<a name="l00320"></a>00320 }
<a name="l00321"></a>00321 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
